/***************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename slots use Qt Designer which will
** update this file, preserving your code. Create an init() slot in place of
** a constructor, and a destroy() slot in place of a destructor.
*****************************************************************************/

static QTextCodec *codec = QTextCodec::codecForLocale();

void Form1::fileOpen()
{
  QString fn;
  
  fn = FileDialog1.getOpenFileName("~/", "Text files (*.txt);;Tengwar files (*.tng)", this);
  if( !fn.isEmpty());
  {
    QFileInfo fi(fn);
    QFile f(fn);

    if(f.open( IO_ReadOnly ))
    {
      QTextStream ts(&f);

      if(fi.extension(FALSE).lower()=="tng")
      {
        TextEdit2->setText(ts.read());
        tfilename=fn;
      }
      else
      {
        TextEdit1->setText(ts.read());
        rfilename=fn;
      }
      f.close();
      updateFonts();
    }
  }
}

void Form1::fileSave()
{
  int state=0; //0 ... nevim co ukladat, 1 ... ukladam levek panel, 2... ukladam pravej panel
  QString filename;

  if((!rfilename.isEmpty())&&(focusWidget()==TextEdit1))
  {
    filename=rfilename;
    state=1;
  }
  else if((!tfilename.isEmpty())&&(focusWidget()==TextEdit2))
  {
    filename=tfilename;
    state=2;
  }
  if(state>0)
  {
    QFile f(filename);

    if(f.open( IO_WriteOnly ))
    {
      QTextStream ts(&f);

      if(state==2)
        ts << TextEdit2->text();
      else /*state==1*/
        ts << TextEdit1->text();
      f.close();
    }
  }
  else
    fileSaveAs();
}

void Form1::fileSaveAs()
{
  QString fn;

  FileDialog1.setFilters(QString("Text files (*.txt);;Tengwar files (*.tng)"));
  FileDialog1.setDir("~/");
  FileDialog1.setMode(QFileDialog::AnyFile);
  if(FileDialog1.exec()==QDialog::Accepted)
    fn=FileDialog1.selectedFile();
  if(!fn.isEmpty())
  {
    QFileInfo fi(fn);
       
    //doplnime odpovidajici koncovku, jestli chybi
    //printf("%s;%s\n", fi.extension(FALSE).latin1(),FileDialog1.selectedFilter().latin1());
    if((fi.extension(FALSE).lower()!="txt")&&(fi.extension(FALSE).lower()!="tng"))
    {
      if(FileDialog1.selectedFilter().contains("txt"))
	fn+=".txt";
      else if(FileDialog1.selectedFilter().contains("tng"))
	fn+=".tng";
      fi.setFile(fn);
    }
    //focusem urcime kterej panel se bude ukladat
    if(fi.extension(FALSE).lower()=="tng")
    {
      TextEdit2->setFocus();
      tfilename=fn;
    }
    else
    {
      TextEdit1->setFocus();
      rfilename=fn;
    }
    fileSave();
  }
}

void Form1::filePrint()
{
        const int Margin = 10;
//        int pageNo = 1;
        QTextEdit *e=TextEdit2;

//Because we don't want to print to the very edges of the paper, we use a little margin: 10 points. Furthermore we keep track of the page count. 
        if ( printer->setup(this) ) {               // printer dialog
//QPrinter::setup() invokes a print dialog, configures the printer object, and returns TRUE if the user wants to print or FALSE if not. So we test the return value; if it's TRUE, we... 
//            statusBar()->message( "Printing..." );
//... set a statusbar message in case printing takes a while. 
            QPainter p;
            if( !p.begin( printer ) )               // paint on printer
                return;
//We create a painter for the output and decide that we wish to paint on the printer or do nothing at all. 
	    p.setFont( e->font() );
            int yPos        = 0;                    // y-position for each line
            QFontMetrics fm = p.fontMetrics();
            QPaintDeviceMetrics metrics( printer ); // need width/height
                                                    // of printer surface
//Then we select the font our QTextEdit object returns as its current one, and set up some variables we'll need. 
            for( int i = 0 ; i < e->lines() ; i++ ) {
//As long as the editing widget contains more lines, we want to print them. 
                if ( Margin + yPos > metrics.height() - Margin ) {
//Before we print a line, we make sure that there is space for it on the current page. If not, we start a new page: 
//                    QString msg( "Printing (page " );
//                    msg += QString::number( ++pageNo );
//                    msg += ")...";
//                    statusBar()->message( msg );
                    printer->newPage();             // no more room on this page
                    yPos = 0;                       // back to top of page
//(Four lines to tell the user what we're doing, two lines to do it.) 
                }
//Now we know that there's space for the current line ... 
                p.drawText( Margin, Margin + yPos,
                            metrics.width(), fm.lineSpacing(),
                            ExpandTabs | DontClip,
                            e->text( i ) );
//... and we use the painter to print it. 
//In Qt, output to printers uses the exact same code as output to screen, pixmaps and picture metafiles. Therefore, we don't call a QPrinter function to draw text, but a QPainter function. QPainter works on all the output devices mentioned and has a device independent API. Most of its code is device independent, too, therefore it is less likely that your application will have odd bugs. (If the same code is used to print and to draw on the screen, it's less likely that you'll have print-only or screen-only bugs.) 
                yPos = yPos + fm.lineSpacing();
//With this line, we keep count of how much of the paper we've used so far. 
            }
            p.end();                                // send job to printer
//At this point we've printed all of the text in the editing widget and told the printer to finish off the last page. 
//            statusBar()->message( "Printing completed", 2000 );
//Finally the user receives the message that we're done. 
        } else {
//            statusBar()->message( "Printing aborted", 2000 );
        }
//If the user did not want to print (and QPrinter::setup() returned FALSE), we inform him or her about it. 
}

void Form1::editRedo()
{
  if(typeid(*focusWidget())==typeid(QTextEdit))
    dynamic_cast<QTextEdit *>(focusWidget())->redo();
}

void Form1::editCut()
{
  if(typeid(*focusWidget())==typeid(QTextEdit))
    dynamic_cast<QTextEdit *>(focusWidget())->cut();
}

void Form1::editCopy()
{
  if(typeid(*focusWidget())==typeid(QTextEdit))
    dynamic_cast<QTextEdit *>(focusWidget())->copy();
}

void Form1::editPaste()
{
  if(typeid(*focusWidget())==typeid(QTextEdit))
    dynamic_cast<QTextEdit *>(focusWidget())->paste();
}

void Form1::editFind()
{
  QTextEdit *e;
  
  if(typeid(*focusWidget())!=typeid(QTextEdit))
    return;
  e=dynamic_cast<QTextEdit *>(focusWidget());
  findwnd->setCaption("Find");
  findwnd->LineEdit2->hide();
  findwnd->TextLabel2->hide();
  findwnd->PushButton2->hide();
  findwnd->PushButton3->hide();
  findwnd->setTextEdit(e);
  findwnd->show();
}

void Form1::editReplace()
{
  QTextEdit *e;
  
  if(typeid(*focusWidget())!=typeid(QTextEdit))
    return;
  e=dynamic_cast<QTextEdit *>(focusWidget());
  findwnd->setCaption("Replace");
  findwnd->LineEdit2->show();
  findwnd->TextLabel2->show();
  findwnd->PushButton2->show();
  findwnd->PushButton3->show();
  findwnd->setTextEdit(e);
  findwnd->show();
}

void Form1::helpIndex()
{

}

void Form1::helpAbout()
{
  QMessageBox::about(this, "About", "YaTT lite v"+YATTVERSION+"\nYet Another Tengwar Tool lite\n\xa9""2001-3 by BLiZZARD\nTranscription engine: "+QString(transcription.GetVersion())+"\n\nE-mail: tnemec@email.cz\nWWW: http://www.jadro.cz/tengwar/index.php");
}

void Form1::loadIni()
{
  QString modetext, modepath, mode, modecodec;
  CIniFile *ini = new CIniFile("settings.ini");

  modecodec = ini->getValue("mode", "codec", "ISO 8859-1").c_str();
  settings.tmfcodec = QTextCodec::codecForName(modecodec);
  modetext = ini->getValue("mode", "lang", "English.tmf").c_str();
  modepath = ini->getValue("mode", "path", "modes/").c_str();
  mode=modepath;
  mode+=modetext;
  doLoadMode(mode);
  
  dict = ini->getValue("dictionary", "file", "que_eng.df").c_str();
  dictpath = ini->getValue("dictionary", "path", "dict/").c_str();
  dict=dictpath+dict;
  doLoadDictionary(dict);
  
  settings.alert = ini->getValue("transcription", "alert", "T")=="T";
  settings.autotrans = ini->getValue("transcription", "auto", "F")=="T";
  settings.clear = ini->getValue("transcription", "clear", "T")=="T";
  settings.smart = ini->getValue("transcription", "smart", "T")=="T";
  settings.separat = ini->getValue("transcription", "separatenums", "T")=="T";
  settings.marknum = ini->getValue("transcription", "digits", "T")=="T";
  settings.marklsd = ini->getValue("transcription", "lsd", "T")=="T";
  settings.base10 = ini->getValue("transcription", "decimal", "F")=="T";
  settings.rcase = (casetype)ini->getInt("general", "AutoCase", 0);
  settings.saveset = ini->getValue("general", "SaveSettingsAtExit", "T")=="T";
  settings.saveenv = ini->getValue("general", "SaveEnvironmentAtExit", "F")=="T";
  if(settings.saveenv)
  {
    if(ini->getValue("environment", "StandardToolBar", "T")!="T")
      viewStandardAction->toggle();
    if(ini->getValue("environment", "DictionaryToolBar", "T")!="T")
      viewDictionaryAction->toggle();
    if(ini->getValue("environment", "MainToolBar", "T")!="T")
      viewTranscriptionAction->toggle();
    if(ini->getValue("environment", "StatusBar", "T")!="T")
      viewStatusAction->toggle();

    romanFont.setFamily(ini->getValue("environment", "RomanFont", "Helvetica").c_str());
    romanFont.setPointSize(ini->getInt("environment", "RomanSize", 12));
    tengwarFont.setFamily(ini->getValue("environment", "TengwarFont", "Tengwar Quenya").c_str());
    tengwarFont.setPointSize(ini->getInt("environment", "TengwarSize", 24));
  }

  delete ini;
}

void Form1::init()
{
  QDesktopWidget d;
  
  move((d.screenGeometry().width()-frameGeometry().width())/2,
       (d.screenGeometry().height()-frameGeometry().height())/2);
  DictWnd = new CDictWnd(this, NULL, FALSE,  WType_Dialog | WStyle_Customize | WStyle_Title | WStyle_DialogBorder);
  findwnd = new findrepdlg(this, NULL, FALSE,  WType_Dialog | WStyle_Customize | WStyle_Title | WStyle_DialogBorder);
  printer = new QPrinter;
  initFileDialogs();
  initPanes();
  initStatusBar();
  romanFont.setFamily("Helvetica");
  romanFont.setPointSize(12);
  tengwarFont.setFamily("Tengwar Quenya");
  tengwarFont.setPointSize(24);
  loadIni();
  initFontCombos();
  //prenastaveni fontu v panelech 
  updateFonts();
}


void Form1::destroy()
{
  delete status1;
  delete status2;
  delete status3;
  delete status4;
  delete printer;
  delete DictWnd;
  delete findwnd;
}

void Form1::initPanes()
{
  //Panes are not the same width on MacOS X ...
  int dw = TextEdit2->width()-TextEdit1->width();
  QValueList<int> list;

  list.push_back(TextEdit1->width()+dw/2);
  list.push_back(TextEdit2->width()-dw/2);
  Splitter2->setSizes(list);

  //One font across for the whole pane
  TextEdit1->setTextFormat(PlainText);
  TextEdit2->setTextFormat(PlainText);
}

void Form1::initStatusBar()
{
  status1 = new QLabel(statusBar());
  status1->setScaledContents(FALSE);
  status1->setFixedWidth(50);
  statusBar()->addWidget(status1, 0, FALSE);
  status2 = new QLabel(statusBar());
  status2->setScaledContents(FALSE);
  status2->setFixedWidth(200);
  statusBar()->addWidget(status2, 0, FALSE);
  status3 = new QLabel(statusBar());
  status3->setScaledContents(FALSE);
  status3->setFixedWidth(120);
  statusBar()->addWidget(status3, 0, FALSE);
  status4 = new QLabel(statusBar());
  status4->setScaledContents(FALSE);
  status4->setFixedWidth(230);
  statusBar()->addWidget(status4, 0, FALSE);
  
  status1->setText( tr("1:1") );
/*
  status2->setText( tr("Tengwar mode") );
  status3->setText( tr("Case insensitive") );
  status4->setText( tr("Credits") );
*/
}


void Form1::initFontCombos()
{
  QListBoxItem *li;
  QString qs;
  
  fontComboBox1->insertStringList(fd.families());
  fontComboBox2->insertStringList(fd.families());
  
  for(int i=fontComboBox1->count()-1; i>=0; i--)
    if(fontComboBox1->text(i).contains("tengwar", FALSE))
      fontComboBox1->removeItem(i);

  for(int i=fontComboBox2->count()-1; i>=0; i--)
    if(!fontComboBox2->text(i).contains("tengwar", FALSE))
      fontComboBox2->removeItem(i);

  //nastavime fonty
  li=fontComboBox1->listBox()->findItem(romanFont.family(), ExactMatch);
  if(!li)
  {
    li=fontComboBox1->listBox()->findItem(romanFont.family(), Contains);
    //kdyz font neexistuje, tak nastavime prvni font co je k dispozici
    if(!li)
      li=fontComboBox1->listBox()->firstItem();
  }
  fontComboBox1->setCurrentText(li->text());
  romanFont.setFamily(li->text());
  qs.setNum(romanFont.pointSize());
  sizeComboBox1->setCurrentText(qs);
  romanFont.setWeight(50/*Normal*/);
  romanFont.setItalic(FALSE);

  li=fontComboBox2->listBox()->findItem(tengwarFont.family(), ExactMatch);
  if(!li)
  {
    li=fontComboBox2->listBox()->findItem(tengwarFont.family(), Contains);
    //kdyz font neexistuje, tak nastavime prvni font co je k dispozici
    if(!li)
    {
      li=fontComboBox2->listBox()->firstItem();
      if(!li)
      {
	//nejsou nainstalovany tengwarove fonty
	QMessageBox::critical(this, "Error", "No tengwar fonts are installed. YaTT will terminate.\nPlease install at least one tengwar font and then run YaTT again.", QMessageBox::Ok, 0, 0);
	QApplication::exit(-1);
      }
    }
  }
  fontComboBox2->setCurrentText(li->text());
  tengwarFont.setFamily(li->text());
  qs.setNum(tengwarFont.pointSize());
  sizeComboBox2->setCurrentText(qs);
  tengwarFont.setWeight(50/*Normal*/);
  tengwarFont.setItalic(FALSE);

}


void Form1::initFileDialogs()
{
    //tady by melo bejt nastaveni defaultnich adresaru, filtry, atd.
}

void Form1::updateFonts()
{
  TextEdit1->selectAll(TRUE);
  TextEdit1->setCurrentFont(romanFont);
  TextEdit1->selectAll(FALSE);
  TextEdit2->selectAll(TRUE);
  TextEdit2->setCurrentFont(tengwarFont);
  TextEdit2->selectAll(FALSE);
//  status1->setText( romanFont.family() );
//  status2->setNum( romanFont.pixelSize() );
//  status3->setText( tengwarFont.family() );
//  status4->setNum( tengwarFont.pixelSize() );
  TextLabel1->setFont(tengwarFont);
  TextLabel1->font().setPointSize(24);
}


void Form1::fontComboBox1_highlighted( const QString & str )
{
  romanFont.setFamily( str );  
  updateFonts();
}


void Form1::fontComboBox2_highlighted( const QString & str )
{
  tengwarFont.setFamily( str );  
  updateFonts();
}


void Form1::sizeComboBox1_highlighted( const QString & str )
{
  bool b;
  int n = str.toInt(&b, 10);
  
  if(b==TRUE)
    romanFont.setPointSize( n );
  updateFonts();
}


void Form1::sizeComboBox2_highlighted( const QString & str )
{
  bool b;
  int n = str.toInt(&b, 10);
  
  if(b==TRUE)
    tengwarFont.setPointSize( n );
  updateFonts();
}


void Form1::sizeComboBox1_textChanged( const QString & str )
{
  sizeComboBox1_highlighted(str);
}

void Form1::sizeComboBox2_textChanged( const QString & str )
{
  sizeComboBox2_highlighted(str);
}

//#include <qdatetime.h>
void Form1::r2tExecute()
{
  QString str;
  QCString cstr;
  QTextStream t;
//  QTime tt;

  if((settings.clear)||(settings.autotrans))
    TextEdit2->setText("");
  
  //TODO: tady se vypne OnChange handler
  
  try
  {
    QApplication::setOverrideCursor(WaitCursor);
    status4->setText( tr("Transcribing ... Press ESC to abort") );
    status4->repaint();
    if(TextEdit1->hasSelectedText())
      str = TextEdit1->selectedText();
    else
      str = TextEdit1->text();
/*    if(settings.tmfcodec)
      t.setCodec(settings.tmfcodec);
    else
      t.setEncoding(QTextStream::Latin1);*/
    cstr = settings.tmfcodec->fromUnicode(str);//codec->toUnicode(str));
    //printf("Roman: %s\n", (const char *)cstr);
//    tt.start();
    cstr = transcription.Roman2Tengwar(cstr);
//    printf("Done after %d miliseconds\n", tt.elapsed());
    //printf("Tengwar: %s\n", (const char *)cstr);
    str = settings.tmfcodec->toUnicode(cstr);
    //str = settings.tmfcodec->toUnicode(cstr+"\nq\xd5");
    cstr = codec->fromUnicode(str);
    TextEdit2->insert(cstr, (bool)TRUE);
  }
  catch(EPatternNotFound &e)
  {
    TransError *dlg = new TransError(this, NULL, TRUE, WStyle_Customize | WStyle_DialogBorder | WType_Dialog | WShowModal);

    //printf("Transcription Error: %s\n", e.what());
    dlg->quote->setText( e.what() );
    dlg->exec();

    delete dlg;
  }
  catch(EAbort &e)
  {
  }
  status4->setText(settings.tmfcodec->toUnicode(transcription.GetModeComment()));
  updateFonts();

  //TODO:kurzor na default
  QApplication::restoreOverrideCursor();
}

void Form1::t2rExecute()
{
  QString str;

  if((settings.clear)||(settings.autotrans))
    TextEdit1->setText("");
  
  //TODO: tady se vypne OnChange handler
  
  try
  {
    QApplication::setOverrideCursor(WaitCursor);
    status4->setText( tr("Transcribing ... Press ESC to abort") );
    status4->repaint();
    if(TextEdit2->hasSelectedText())
      str = transcription.Tengwar2Roman(TextEdit2->selectedText());
    else
      str = transcription.Tengwar2Roman(TextEdit2->text());
    TextEdit1->insert(str, (bool)TRUE);
  }
  catch(EPatternNotFound &e)
  {
    TransError *dlg = new TransError(this, NULL, TRUE, WStyle_Customize | WStyle_DialogBorder | WType_Dialog | WShowModal);

    //printf("Transcription Error: %s\n", e.what());
    dlg->quote->setText( e.what() );
    dlg->exec();

    delete dlg;
  }
  catch(EAbort &e)
  {
  }
  status4->setText(transcription.GetModeComment());
  updateFonts();

  //TODO:kurzor na default
  QApplication::restoreOverrideCursor();
}


void Form1::loadModeExecute()
{
    //udelat poradne
  QString fn;
    
  fn = FileDialog1.getOpenFileName("./modes/", "Tengwar Mode Files (*.tmf *.mod)", this);
  if( !fn.isEmpty())
    doLoadMode(fn);
}


void Form1::cursorMove( int x, int y)
{
  QString s1, s2;
  
  s1.setNum(x+1, 10);
  s2.setNum(y+1, 10);
  s1+=':';
  s1+=s2;
  status1->setText( s1 );
}


void Form1::settingsExecute()
{
  CSettingsDlg *dlg = new CSettingsDlg (this, NULL, TRUE,  WType_Dialog | WStyle_Customize | WStyle_Title | WStyle_DialogBorder);

  //nastavit widgety
  dlg->chkAuto->setChecked(settings.autotrans);
  dlg->chkSmart->setChecked(settings.smart);
  dlg->chkClear->setChecked(settings.clear);
  dlg->rbAlertStop->setChecked(settings.alert);
  dlg->rbQuest->setChecked(!settings.alert);
  dlg->chkSeparat->setChecked(settings.separat);
  dlg->chkMark->setChecked(settings.marknum);
  dlg->chkMarkLSD->setChecked(settings.marklsd);
  dlg->rbBase10->setChecked(settings.base10);
  dlg->rbBase12->setChecked(!settings.base10);
  if(dlg->rbBase10->isOn())
  {
      dlg->chkMarkLSD->setEnabled(FALSE);
      if(dlg->chkMarkLSD->isOn())
        dlg->chkMarkLSD->toggle();
  }
  //printf("current codec: %s\n", settings.tmfcodec ? settings.tmfcodec->name() : "NULL");
  dlg->setCodec(settings.tmfcodec);
  switch(settings.rcase)
  {
    case NOCASE:
      dlg->rbCaseNo->setChecked(TRUE);
      break;
    case UCASE:
      dlg->rbCaseUpper->setChecked(TRUE);
      break;
    case LCASE:
      dlg->rbCaseLower->setChecked(TRUE);
      break;
    case AUTOCASE:
      dlg->rbCaseAuto->setChecked(TRUE);
      break;
  }
  dlg->chkSaveSettings->setChecked(settings.saveset);
  dlg->chkSaveEnv->setChecked(settings.saveenv);
    
  if(dlg->exec()==QDialog::Accepted)
  {
    //ulozit nastaveni
    settings.autotrans=dlg->chkAuto->isChecked();
    settings.smart=dlg->chkSmart->isChecked();
    settings.clear=dlg->chkClear->isChecked();
    settings.alert=dlg->rbAlertStop->isChecked();
    settings.separat=dlg->chkSeparat->isChecked();
    settings.marknum=dlg->chkMark->isChecked();
    settings.marklsd=dlg->chkMarkLSD->isChecked();
    settings.base10=dlg->rbBase10->isChecked();
    //pri AUTO rezimu musime cistit cilovy panel
    if(settings.autotrans)
      settings.clear=TRUE;
    if(dlg->rbCaseNo->isChecked())
      settings.rcase=NOCASE;
    else if(dlg->rbCaseUpper->isChecked())
      settings.rcase=UCASE;
    else if(dlg->rbCaseLower->isChecked())
      settings.rcase=LCASE;
    else if(dlg->rbCaseAuto->isChecked())
      settings.rcase=AUTOCASE;
    settings.saveset=dlg->chkSaveSettings->isChecked();
    settings.saveenv=dlg->chkSaveEnv->isChecked();
    settings.tmfcodec=dlg->getCodec();
    //printf("Codec set to: %s\n", settings.tmfcodec ? settings.tmfcodec->name() : "NULL");

    //nastavit engine podle parametru
    transcription.SetSmart(settings.smart);
    transcription.SetAlert(settings.alert);
    transcription.SetSeparateNums(settings.separat);
    transcription.SetDigits(settings.marknum);
    transcription.SetLSD(settings.marklsd);
    transcription.SetDecimal(settings.base10);
  }
  
  delete dlg;
}

void Form1::loadDictionary()
{
  QString fn;

  fn = FileDialog1.getOpenFileName("./dict/", "Dictionary Files (*.df)", this);
  if( !fn.isEmpty());
    doLoadDictionary(fn);
}

void Form1::showDictionary()
{
  DictWnd->show();
}


void Form1::textChanged()
{
  int para, ind;
  static bool zamek=FALSE;
  
  if(zamek)
    return;
  zamek=TRUE;
  TextEdit1->getCursorPosition(&para, &ind);
  switch(settings.rcase)
  {
    case UCASE:
      TextEdit1->setText(TextEdit1->text().upper());
      break;
    case LCASE:
      TextEdit1->setText(TextEdit1->text().lower());
      break;
    case AUTOCASE:
      TextEdit1->setText(smartCase(TextEdit1->text()));
      break;
    case NOCASE:
      break;
  }
  TextEdit1->setCursorPosition(para, ind);
  if(settings.autotrans)
  {
    if(focusWidget()==TextEdit1)
      r2tExecute();
    else if(focusWidget()==TextEdit2)
      t2rExecute();    
  }
  zamek=FALSE;
}


void Form1::doLoadDictionary( QString fn )
{
  char str[16];

  //naparsujeme XML
  CDictParser handler;
  QFile xmlFile( fn );
  QXmlInputSource source( &xmlFile );
  QXmlSimpleReader reader;
  int n;
  
  try
  {
    QApplication::setOverrideCursor(WaitCursor);
    n=fn.findRev('/');
    dictpath=fn.left(n+1);
    dict=fn;
    handler.tagnames=&DictWnd->styleNames;
    handler.begintags=&DictWnd->styleBeginTags;
    handler.endtags=&DictWnd->styleEndTags;
    handler.lb=DictWnd->ListBox1;
    handler.meanings=&DictWnd->meanings;
    handler.copylabel=DictWnd->copyright;
    handler.copylabel->setText("");
    handler.meanings->clear();
    handler.lb->clear();
    reader.setContentHandler( &handler );
    reader.parse( source );
    snprintf(str, sizeof(str), "%d entries", handler.lb->count());
    DictWnd->numentries->setText(str);
    QApplication::restoreOverrideCursor();
  }
  catch(exception &e)
  {
    printf("Error loading dictionary %s\n", fn.latin1());
  }
}

void Form1::doLoadMode( QString fn )
{
  QString str;
  QCString cstr;
  
  try
  {
    transcription.LoadMode(fn.latin1());
  }
  catch(exception &e)
  {
    printf("Error loading mode %s\n", fn.latin1());
  }
  status2->setText(transcription.GetModeName());
  status3->setText( tr(transcription.GetModeCaseSensitivity() ? "Case Sensitive" : "Case Insensitive") );
  cstr=transcription.GetModeComment();
  str = settings.tmfcodec->toUnicode(cstr);
  status4->setText(str);
}

QString Form1::smartCase( QString str )
{
  QChar last='.';
  bool lastspace=TRUE;

  for(unsigned i=0;i<str.length();i++)
  {
    if(str[i].isLetterOrNumber())
      if(lastspace)
	switch(last)
	{
	  case '.':
	  case ';':
	  case '!':
	  case '?':
	    str[i]=str[i].upper();
	    break;
	  default:
	    str[i]=str[i].lower();
	}
    if(!str[i].isSpace())
    {
      last=str[i];
      lastspace=FALSE;
    }
    else
      lastspace=TRUE;
  }

  return str;
}


void Form1::viewStandardToggled( bool b)
{
  if(b)
    toolBar1->show();
  else
    toolBar1->hide();
}

void Form1::viewDictionaryToggled( bool b)
{
  if(b)
    toolBar2->show();
  else
    toolBar2->hide();
}

void Form1::viewTranscriptionToggled( bool b)
{
  if(b)
    toolBar3->show();
  else
    toolBar3->hide();
}


void Form1::viewStatusToggled( bool b)
{
  if(b)
    statusBar()->show();
  else
    statusBar()->hide();
}



void Form1::saveEnvironment()
{
  CIniFile *ini = new CIniFile("settings.ini");

  ini->setValue("environment", "StandardToolBar", tf(toolBar1->isVisible()));
  ini->setValue("environment", "DictionaryToolBar", tf(toolBar2->isVisible()));
  ini->setValue("environment", "MainToolBar", tf(toolBar3->isVisible()));
   ini->setValue("environment", "StatusBar", tf(statusBar()->isVisible()));
  ini->setValue("environment", "RomanFont", (const char *)romanFont.family());
  ini->setInt("environment", "RomanSize", romanFont.pointSize());
  ini->setValue("environment", "TengwarFont", (const char *)tengwarFont.family());
  ini->setInt("environment", "TengwarSize", tengwarFont.pointSize());
      
  delete ini;
}

void Form1::saveSettings()
{
  CIniFile *ini = new CIniFile("settings.ini");

  ini->setValue("mode", "lang", transcription.GetModeName());
  ini->setValue("mode", "path", transcription.GetModePath());
  ini->setValue("mode", "codec", settings.tmfcodec->name());
  ini->setValue("dictionary", "file", dict.section('/',-1).latin1());
  ini->setValue("dictionary", "path", dictpath.latin1());
  ini->setValue("transcription", "alert", tf(settings.alert));
  ini->setValue("transcription", "auto", tf(settings.autotrans));
  ini->setValue("transcription", "smart", tf(settings.smart));
  ini->setValue("transcription", "clear", tf(settings.clear));
  ini->setValue("transcription", "separatenums", tf(settings.separat));
  ini->setValue("transcription", "digits", tf(settings.marknum));
  ini->setValue("transcription", "lsd", tf(settings.marklsd));
  ini->setValue("transcription", "decimal", tf(settings.base10));
  ini->setInt("general", "AutoCase", settings.rcase);
  ini->setValue("general", "SaveSettingsAtExit", tf(settings.saveset));
  ini->setValue("general", "SaveEnvironmentAtExit", tf(settings.saveenv));
      
  delete ini;
}


void Form1::closeEvent( QCloseEvent *event )
{
  event->accept();
  if(settings.saveset)
    saveSettings();
  if(settings.saveenv)
    saveEnvironment();
}


void Form1::resizeEvent( QResizeEvent * )
{
  Splitter2->resize(width()-leftDock()->width()-rightDock()->width(),
                    height()-menuBar()->height()-statusBar()->height()-topDock()->height()-bottomDock()->height());
}


void Form1::showEvent( QShowEvent * )
{
  //spustit resizeEvent handler - nastaveni velikosti panelu
  resize(width()+1, height()+1);
}
