#include <qxml.h>
#include <qlabel.h>
#include <qlistbox.h>

class CDictParser : public QXmlDefaultHandler
{
  private:
    bool valid, copyright;
  public:
    QStringList *tagnames, *begintags, *endtags, *meanings;
    QLabel *copylabel;
    QListBox *lb;
    bool startDocument();
    bool startElement(const QString &, const QString &, const QString &, const QXmlAttributes &);
    bool characters(const QString &);
    bool endElement(const QString &, const QString &, const QString &);
};
