#include <qapplication.h>
#include <qdatetime.h>
#include "form1.h"
#include "splash.h"

int main( int argc, char ** argv )
{
  int res;
  QTime *t;
  QApplication a( argc, argv );
  CSplash *splash = new CSplash(NULL, NULL, FALSE, Qt::WType_Dialog | Qt::WStyle_Customize | Qt::WStyle_NoBorder | Qt::WStyle_StaysOnTop);

  splash->show();
  a.processEvents();  
  t = new QTime();
  t->start();
  a.connect( &a, SIGNAL( lastWindowClosed() ), &a, SLOT( quit() ) );
  Form1 *w = new Form1;
  w->show();
  while(t->elapsed()<3000);
  delete t;
  delete splash;
  res = a.exec();
  delete w;

  return res;
}
