/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename slots use Qt Designer which will
** update this file, preserving your code. Create an init() slot in place of
** a constructor, and a destroy() slot in place of a destructor.
*****************************************************************************/


void CSettingsDlg::init()
{
    codecList = new QPtrList<QTextCodec>;
    QTextCodec *codec;
    int i;

    currcodec=QTextCodec::codecForLocale();
    //printf(".\n");
    for (i = 0; (codec = QTextCodec::codecForIndex(i)); i++)
    {
        codecList->append( codec );
        ComboBox1->insertItem( codecList->at(i)->name() );
        //printf("%d\n", i);
	if(QString(codec->name())==QString(currcodec->name()))
	{
	  //printf("setting %s\n", codec->name());
	  ComboBox1->setCurrentItem(i);
	}
    }
}

void CSettingsDlg::destroy()
{
  delete codecList;
}

QTextCodec *CSettingsDlg::getCodec()
{
  return codecList->at(ComboBox1->currentItem());
}

void CSettingsDlg::setCodec(QTextCodec *c)
{
  currcodec=c;
  if(!currcodec)
    currcodec=QTextCodec::codecForLocale();
  for(int i=0; i<ComboBox1->count(); i++)
    if(ComboBox1->text(i)==currcodec->name())
    {
      ComboBox1->setCurrentItem(i);
      break;
    }
}


void CSettingsDlg::numBaseClicked()
{
  if(sender()==rbBase10)
  {
    chkMarkLSD->setEnabled(FALSE);
    if(chkMarkLSD->isOn())
      chkMarkLSD->toggle();
  }
  else if(sender()==rbBase12)
  {
    chkMarkLSD->setEnabled(TRUE);
  }
}
